' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright
VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmQuery 
   ClientHeight    =   6690
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7305
   ScaleHeight     =   6690
   ScaleWidth      =   7305
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton buttonRun 
      Caption         =   "Run Query"
      Height          =   375
      Left            =   3000
      TabIndex        =   3
      Top             =   1440
      Width           =   1335
   End
   Begin MSComctlLib.ListView lvQryResults 
      Height          =   4455
      Left            =   120
      TabIndex        =   2
      Top             =   2160
      Width           =   7095
      _ExtentX        =   12515
      _ExtentY        =   7858
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Document Title"
         Object.Width           =   5080
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "File Name"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.TextBox txtQuery 
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   960
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "cmbxDDQuery.frx":0000
      ToolTipText     =   "Enter FTSearch Query (multi-line ok)"
      Top             =   480
      Width           =   6255
   End
   Begin VB.Label lblQueryText 
      Caption         =   "QueryTxt"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   735
   End
End
Attribute VB_Name = "frmQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub buttonRun_Click()
  On Error GoTo buttonRun_Click_err

  Dim cabid As String
  cabid = frmQuery.Tag
  Dim theCabinet As DXCabinetDefDD
  Set theCabinet = dsDD.getEntityById(DX_DD_ENT_CABINET, cabid)
  Dim tmpDocuments As DXSequentialCollectionDD
  frmQuery.MousePointer = vbHourglass

  ' Search the cabinet for documents, DKResults are returned.
  Dim rCursor As DXResultSetCursorScrollableDD
  Dim commandString As String
  commandString = "ENTITY=" & theCabinet.getName & ";QUERY=" & frmQuery.txtQuery
  Set rCursor = dsDD.execute(commandString, DX_DD_PARAMETRIC_QL_TYPE)

  ' How many documents returned?
  Dim nbrDocs As Long
  nbrDocs = rCursor.cardinality
  If nbrDocs = 0 Then
    MsgBox "No documents found."
    Exit Sub
  Else

  ' Example: Test cursor position
  Dim bPos As Boolean
  bPos = rCursor.isBegin
  bPos = rCursor.isEnd
  bPos = rCursor.isInBetween

  lvQryResults.ListItems.Clear
  lvQryResults.View = lvwReport
  Dim tmpListItem As ListItem

  Dim ddo As DXDDODD
  If rCursor.isValid Then
    Set ddo = rCursor.fetchFirst
  End If
  Do While (ddo Is Nothing) = False

    ' get meta data about the data object
    Dim nbrProps As Integer
    nbrProps = ddo.propertyCount ' ddo meta data
    For x = 1 To nbrProps
      Dim propName As String
      Dim propValue As String
      propName = ddo.getPropertyName(x)
      propValue = ddo.getProperty(x)
    Next x

    ' get data item's unique id (the doc id from domino.doc)
    Dim docId As String
    Dim pid As DXPidDD
    Set pid = ddo.getPidObject
    docId = pid.getPrimaryId

    ' example loop through document's meta data (save title and filename for display)
    Dim nbrDataItems As Integer
    nbrDataItems = ddo.dataCount ' document meta data

    Dim docTitle As String
    Dim fileName As String

    For x = 1 To nbrDataItems
      Dim dataName As String
      Dim dataValue As String
      dataName = ddo.getDataName(x)
      dataValue = ddo.GetData(x)
      If dataName = DX_DD_TITLE Then
        docTitle = dataValue
      ElseIf dataName = DX_DD_FILENAME Then
          fileName = dataValue
      End If
    Next x

    ' Fill in list view
    Set tmpListItem = lvQryResults.ListItems.Add(, , docTitle)
    tmpListItem.Tag = docId
    tmpListItem.SubItems(1) = fileName

    Set ddo = rCursor.fetchNext

  Loop ' end loop on valid cursor

  frmQuery.MousePointer = vbDefault





  End If
  Exit Sub
buttonRun_Click_err:
  MsgBox Err.Description, , "Query Execution Error"
  frmQuery.MousePointer = vbDefault
End Sub

Private Sub lvQryResults_ItemClick(ByVal Item As MSComctlLib.ListItem)
  On Error GoTo lvQryResults_ItemClick_Err

  Dim theDocument As DXDocumentDefDD
  Dim sDocId As String
  sDocId = Item.Tag

  Set theDocument = dsDD.getEntityById(DX_DD_ENT_DOCUMENT, sDocId)

  Dim fProps As New frmDocProp

  fProps.lvAttrNames.ListItems.Clear
  fProps.lvAttrNames.View = lvwReport
  Dim tmpListItem As ListItem

  Dim tmpFields As DXSequentialCollectionDD

  Dim tmpField As DXAttrDefDD

  Set tmpFields = theDocument.listAttrs

  If tmpFields Is Nothing Then
    ' nothing to do
  Else
    Dim itFields As DXSequentialIteratorDD
    Set itFields = tmpFields.createIterator

    Do While itFields.more
      Set tmpField = itFields.Next
      Set tmpListItem = fProps.lvAttrNames.ListItems.Add(, , tmpField.getName)
      tmpListItem.Tag = tmpField.getValue
    Loop ' end do while itFields.more
  End If ' end if collection is not nothing



  fProps.Show vbModal

'  fProps.Hide

  Exit Sub

lvQryResults_ItemClick_Err:
  MsgBox Err.Description, , "ItemClick_Err"
End Sub
