/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

/*
 * Filename       : TAddXDODL.cpp
 * Description    : this sample requires you to know the existing itemId 
 *                  in the library. 
 *                  Specify the itemId, partId & fileName that you wish to add
 *                  Specify no parameters to see different ways to call this
 *                  sample to add a text part that to that you wish to be
 *                  indexed by Text Search or add an image part
 *                  that you wish to be indexed by QBIC.
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstantDL.h>
#include <DKDatastoreDL.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <dkResultSetCursor.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <DKBlobDL.hpp>
#include <DKPidXDODL.hpp>
#include <DKDatastoreTS.hpp>
#include <DKDatastoreDefTS.hpp>
#include <DKDatastoreAdminTS.hpp>
#include <DKSearchIndexDefTS.hpp>
#include <DKDatastoreQBIC.hpp>
#include <DKEnvironment.hpp>

void displayDDO(DKDDO* ddo);

void main(int argc, char *argv[])
{
    cout << "begin..." << endl;

    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    DKString libsrv;
    DKString userid;
    DKString pw;
    DKString strPartId;
    long partId = 22;
    DKString srchSrv = "";
    DKString srchIndex = "";
    DKString searchEngine = "";
    DKString searchIndex = "";
    DKString searchInfo = "";
    DKString qbicSrv = "";
    DKString qbicDB = "";
    DKString qbicCat = "";
    DKBoolean fText = FALSE;
    DKBoolean fQBIC = FALSE;
    DKString fileName = "txt.gif";
    DKString itemId = "S3BNAA86MPHKUL7S";
    if (argc == 9)
    {
     libsrv = DKString(argv[1]);
     userid = DKString(argv[2]);
     pw = DKString(argv[3]);
     strPartId = DKString(argv[4]);
     partId = strPartId.asInt();
     fileName = DKString(argv[5]);
     qbicSrv = DKString(argv[6]);
     qbicDB = DKString(argv[7]);
     qbicCat = DKString(argv[8]);
     cout << "You enter: TAddXDODL " << libsrv << " " << userid <<
	 " " << strPartId << " " << fileName << " " << qbicSrv <<
         " " << qbicDB << " " << qbicCat << endl;
     fQBIC = TRUE;
     searchEngine = "QBIC";
     searchInfo = "ENU";
     searchIndex = qbicDB;
     searchIndex = searchIndex + "-";
     searchIndex = searchIndex + qbicCat;
     searchIndex = searchIndex + "-";
     searchIndex = searchIndex + qbicSrv;
    }
    else if (argc == 8)
    {
     libsrv = DKString(argv[1]);
     userid = DKString(argv[2]);
     pw = DKString(argv[3]);
     strPartId = DKString(argv[4]);
     partId = strPartId.asInt();
     fileName = DKString(argv[5]);
     srchSrv = DKString(argv[6]);
     srchIndex = DKString(argv[7]);
     cout << "You enter: TAddXDODL " << libsrv << " " << userid <<
	 " " << strPartId << " " << fileName << " " << srchSrv <<
         " " << srchIndex << endl;
     fText = TRUE;
     searchEngine = "SM";
     searchInfo = "ENU";
     searchIndex = srchSrv;
     searchIndex = searchIndex + "-";
     searchIndex = searchIndex + srchIndex;
    }
    else if (argc == 6)
    {
     libsrv = DKString(argv[1]);
     userid = DKString(argv[2]);
     pw = DKString(argv[3]);
     strPartId = DKString(argv[4]);
     partId = strPartId.asInt();
     fileName = DKString(argv[5]);
     cout << "You enter: TAddXDODL " << libsrv << " " << userid <<
	 " " << strPartId << " " << fileName << endl;
    }
    else
    {
     cout<<"Usage: To add a part "<<endl;
     cout<<"  TAddXDODL <libsrv> <userid> <pw> <partId> <filename>" << endl;
     cout<< "                              or " << endl;
     cout<< " To add a part indexed by TS " << endl;
     cout<<"  TAddXDODL <libsrv> <userid> <pw> <partId> <filename> <TextSrv> <TextSrchIndex>" << endl;
     cout<< "                              or " << endl;
     cout<< " To add a part indexed by QBIC " << endl;
     cout<<"  TAddXDODL <libsrv> <userid> <pw> <partId> <filename> <QBICSrv> <QBICDB> <QBICCAT>" << endl;
     return;
    }

    DKDatastoreDL *dsDL = new DKDatastoreDL(); // must be outside try/catch block
    DKDatastoreTS *dsTS = 0;
    DKDatastoreQBIC *dsQBIC = 0;

    // ### get input parameters
    try {
    DKDatastoreDefTS *dsDefTS = 0;
    DKDatastoreAdminTS *dsAdminTS = 0;
    DKSearchIndexDefTS *pIndx = 0;

    cout << "Datastore DL created" << endl;
    cout << "connecting to datastore" << endl;
    dsDL->connect(libsrv,userid,pw);
    cout << "datastore connected " << libsrv << " userid - " << userid << endl;
     if (fText == TRUE)
     {
      cout << "verify TS datastore" << endl; 
      dsTS = new DKDatastoreTS();
      dsTS->connect(srchSrv,"","","");
      cout << "datastore TS connected" << endl; 
      dsDefTS = (DKDatastoreDefTS*)dsTS->datastoreDef();
      dsAdminTS = (DKDatastoreAdminTS*)dsDefTS->datastoreAdmin();
      cout << "get search index" << endl; 
      pIndx = (DKSearchIndexDefTS*)dsDefTS->getEntity(srchIndex);
      cout << "got search index" << endl; 
      delete pIndx;
     }

     if (fQBIC == TRUE)
     {
      cout << "verify QBIC datastore" << endl; 
      dsQBIC = new DKDatastoreQBIC();
      dsQBIC->connect(qbicSrv,userid,pw,"");
      cout << "datastore QBIC connected" << endl;
      dsQBIC->openCatalog(qbicDB, qbicCat);
      cout << "Catalog opened " << endl;
      dsQBIC->closeCatalog();
      cout << "Catalog closed" << endl;
      dsQBIC->disconnect();
      cout << "datastore QBIC disconnected" << endl; 
     }

    DKBlobDL* axdo = new DKBlobDL(dsDL);
    DKPidXDODL apid;
    apid.setPartId(partId);
    apid.setPrimaryId(itemId);
    axdo->setPidObject(&apid);
    axdo->setContentClass(DK_DL_CC_ASCII);
    axdo->setContentFromClientFile(fileName);

    // indexing
    if (fText == TRUE || fQBIC == TRUE)
    {
     cout << "part is to be indexed " << endl;
     axdo->setSearchEngine(searchEngine);
     axdo->setSearchIndex(searchIndex);
     axdo->setSearchInfo(searchInfo);
     cout << "search engine " + searchEngine << endl;
     cout << "search index " + searchIndex << endl;
     cout << "search info " + searchInfo << endl;
    }
    axdo->add();
cout << "add successfully....." << endl;
    cout << "after add partId = " <<
	((DKPidXDODL*) (axdo->getPid()))->getPartId() << endl;

    cout << "after add itemId = " 
	<< ((DKPidXDODL*) (axdo->getPidObject()))->getPrimaryId() << endl;

    cout << "about to do retrieve()..."<< endl;
    axdo->retrieve();

    cout << "after retrieve() repType=" << axdo->getRepType() << endl; 
    cout << "after retrieve() length=" << axdo->length()<< endl; 
    long cc = axdo->getContentClass();
    cout << "Content class " << cc << endl;

    delete axdo;

    dsDL->disconnect();
    cout << "datastore disconnected" << endl;
    delete dsDL;
     if (dsTS != 0)
     {
      delete dsTS;
     }
     if (dsQBIC != 0)
     {
      delete dsQBIC;
     }
    }
    catch(DKException &exc)
    {

      cout << "Error id " << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }
    cout << "done ..." << endl;

}

void displayDDO(DKDDO* ddo) {
     DKString dataName;
     DKAny any;

     /* --------------------------------------------- */
     cout << " item id[" << ((DKPid*)ddo->getPidObject())->getPrimaryId() << "]  " << endl;
     for (unsigned short j = 1; j <= ddo->dataCount(); j++) {
         dataName = ddo->getDataName(j);
         cout << " attr[" << j << "] = "
              << dataName  << ", \t\t value "
              << ddo->getData(j) << endl;
     }
     /* ------------------------------------------------*/
}
