echo .
echo ". ================================================  "
echo ". IBM Information Integrator for Content V8.2       "
echo ". ------------------------------------------------  "
echo ". Tool Script:  compileSamplesICM.sh  [AIX]         "
echo ". Description:  Compile All ICM C++ Samples         "
echo ". ================================================  "
echo ".                                                   "
echo ". Compile All Samples                               "
echo ".      This tool compiles all C++ API Samples for   "
echo ".      the ICM connector located in this directory. "
echo ".      All files in the 'bin' subfolder will be     "
echo ".      deleted.                                     "
echo ".                                                   "
echo ". Prepare Resource Files Needed                     "
echo ".      All resource files used will also be copied  "
echo ".      to the 'bin' subdirectory.                   "
echo ".                                                   "
echo ". Output                                            "
echo ".      The compiled samples and any resource files  "
echo ".      they use will appear in the 'bin' subfolder. "
echo ".                                                   "
echo ". Prerequisits                                      "
echo ".      The Information Integrator Development       "
echo ".      Environment must be set.  The environment    "
echo ".      script, cmbenv81, may be used.  The          "
echo ".      following environment variables must be      "
echo ".      set correctly.                               "
echo ".       - CMBROOT  :  Root Directory of Information "
echo ".                     Integrator for Content        "
echo ".                     Ex: /usr/lpp/cmb              "
echo ".                                                   "
echo ". ================================================  "
echo .
echo . ------------------------------------------------
echo . Deleting 'bin' subfolder contents...
echo . ------------------------------------------------
rm -R ./bin
echo .
echo . ------------------------------------------------
echo . Compiling Samples...
echo . ------------------------------------------------
make -f SAttributeDefinitionCreationICM.mak.aix
make -f SAttributeDefinitionDeletionICM.mak.aix
make -f SAttributeDefinitionRetrievalICM.mak.aix
make -f SAttributeDefinitionUpdateICM.mak.aix
make -f SAttributeGroupDefCreationICM.mak.aix
make -f SAttributeGroupDefDeletionICM.mak.aix
make -f SAttributeGroupDefRetrievalICM.mak.aix
make -f SAttributeGroupDefUpdateICM.mak.aix
make -f SConnectDisconnectICM.mak.aix
make -f SDocModelItemICM.mak.aix
make -f SDocRoutingDefinitionCreationICM.mak.aix
make -f SDocRoutingDefinitionDeletionICM.mak.aix
make -f SDocRoutingListingICM.mak.aix
make -f SDocRoutingProcessingICM.mak.aix
make -f SFolderICM.mak.aix
make -f SInsuranceModelItemCreationICM.mak.aix
make -f SInsuranceModelItemDeletionICM.mak.aix
make -f SInsuranceModelItemRetrievalICM.mak.aix
make -f SItemCreationICM.mak.aix
make -f SItemDeletionICM.mak.aix
make -f SItemRetrievalICM.mak.aix
make -f SItemTypeCreationICM.mak.aix
make -f SItemTypeDeletionICM.mak.aix
make -f SItemTypeRetrievalICM.mak.aix
make -f SItemTypeUpdateICM.mak.aix
make -f SItemUpdateICM.mak.aix
make -f SLinksICM.mak.aix
make -f SLinkTypeDefinitionCreationICM.mak.aix
make -f SLinkTypeDefinitionDeletionICM.mak.aix
make -f SLinkTypeDefinitionRetrievalICM.mak.aix
make -f SLinkTypeDefinitionUpdateICM.mak.aix
make -f SReferenceAttrDefCreationICM.mak.aix
make -f SReferenceAttrDefDeletionICM.mak.aix
make -f SReferenceAttrDefRetrievalICM.mak.aix
make -f SReferenceAttrDefUpdateICM.mak.aix
make -f SResourceItem3rdPartyIngestICM.mak.aix
make -f SResourceItem3rdPartyRetrieveICM.mak.aix
make -f SResourceItem3rdPartyUpdateICM.mak.aix
make -f SResourceItemCreationICM.mak.aix
make -f SResourceItemDeletionICM.mak.aix
make -f SResourceItemRetrievalICM.mak.aix
make -f SResourceItemUpdateICM.mak.aix
make -f SResourceMgrDefCreationICM.mak.aix
make -f SResourceMgrDefDeletionICM.mak.aix
make -f SResourceMgrDefRetrievalICM.mak.aix
make -f SResourceMgrDefSetDefaultICM.mak.aix
make -f SSampleModelBuildICM.mak.aix
make -f SSampleModelDeleteICM.mak.aix
make -f SSampleModelItemDeletionICM.mak.aix
make -f SSearchICM.mak.aix
make -f SSemanticTypeCreationICM.mak.aix
make -f SSemanticTypeDeletionICM.mak.aix
make -f SSemanticTypeRetrievalICM.mak.aix
make -f SSemanticTypeUpdateICM.mak.aix
make -f SSMSCollectionDefCreationICM.mak.aix
make -f SSMSCollectionDefDeletionICM.mak.aix
make -f SSMSCollectionDefRetrievalICM.mak.aix
make -f SSMSCollectionDefSetDefaultICM.mak.aix
make -f STextIndexUpdateICM.mak.aix
make -f STransactionsICM.mak.aix
make -f SVideoItemCreateICM.mak.aix
make -f SVideoItemDeletionICM.mak.aix
make -f SVideoItemPlayICM.mak.aix
make -f SVideoItemRetrievalICM.mak.aix
make -f SVideoItemTypeCreateICM.mak.aix
make -f SVideoItemTypeDeleteICM.mak.aix
make -f SVideoItemUpdateICM.mak.aix
echo .
echo . ------------------------------------------------
echo . Copying Resource Files to 'bin' subfolder...
echo . ------------------------------------------------
cp SInsuranceModelICM_AccidenReport_0120200130.tif ./bin/.
cp SInsuranceModelICM_AccidenReport_0506200110.tif ./bin/.
cp SInsuranceModelICM_AccidenReport_729200173.tif ./bin/.
cp SInsuranceModelICM_AccidenReport_CABlank.pdf ./bin/.
cp SInsuranceModelICM_AccidenReport_NYBlank.pdf ./bin/.
cp SInsuranceModelICM_Adjustment_4-852369.tif ./bin/.
cp SInsuranceModelICM_Adjustment_5-654123.tif ./bin/.
cp SInsuranceModelICM_Adjustment_6-987654.tif ./bin/.
cp SInsuranceModelICM_Adjustment_Blank.pdf ./bin/.
cp SInsuranceModelICM_Claim_4-852369.tif ./bin/.
cp SInsuranceModelICM_Claim_5-654123.tif ./bin/.
cp SInsuranceModelICM_Claim_6-987654.tif ./bin/.
cp SInsuranceModelICM_Claim_Blank.pdf ./bin/.
cp SInsuranceModelICM_Photo_1ABC089.jpg ./bin/.
cp SInsuranceModelICM_Photo_4IBM134-1.tif ./bin/.
cp SInsuranceModelICM_Photo_4IBM134-2.tif ./bin/.
cp SInsuranceModelICM_Photo_6usa676-1.tif ./bin/.
cp SInsuranceModelICM_Photo_6usa676-2.tif ./bin/.
cp SInsuranceModelICM_Policy_10285265410.tif ./bin/.
cp SInsuranceModelICM_Policy_10315975308.tif ./bin/.
cp SInsuranceModelICM_Policy_10452136412.tif ./bin/.
cp SInsuranceModelICM_Policy_Blank.pdf ./bin/.
cp SResourceItemICM_Document1.doc ./bin/.
cp SResourceItemICM_Document2.doc ./bin/.
cp SResourceItemICM_Picture1.bmp ./bin/.
cp SResourceItemICM_Picture2.bmp ./bin/.
cp SResourceItemICM_Text1.txt ./bin/.
cp SResourceItemICM_Text2.txt ./bin/.
cp SVideoItemICM_Video1.mpg ./bin/.
cp SVideoItemICM_Video2.mpg ./bin/.
echo .
echo ". ================================================  "
echo ". Script Completed.                                 "
echo ". ------------------------------------------------  "
echo ". NOTE:  Do not forget to review 'Getting Started'  "
echo ".        and the complete functionality to sample   "
echo ".        mapping in the 'Reference Index' sections  "
echo ".        of the README_SAMPLES_C++_ICM.txt file.    "
echo ". ================================================  "
echo .