// ----------------------------------------------------------------------------
// @copyright(disclaimer) 
// Licensed Materials - Property of IBM
// IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
// (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
// 
// US Government Users Restricted Rights                                  
// Use, duplication or disclosure restricted by GSA ADP Schedule          
// Contract with IBM Corp.     
// 
// DISCLAIMER OF WARRANTIES :                                             
//                                                                        
// Permission is granted to copy and modify this  Sample code, and to
// distribute modified versions provided that both the copyright        notice,-
// and this permission notice and warranty disclaimer  appear in all copies and
// modified  versions. 
// 
// THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM  AND ITS SUPPLIERS AND LICENSORS
// DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE,
// INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL
// IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT
// OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE
// SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN
// NO EVENT SHALL IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST
// REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
// CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
// REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR
// SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                   
// @endCopyright       
// ----------------------------------------------------------------------------

//******************************************************************************
//*
//* Source File Name = TExecuteWithCallbackDD.CPP
//*
//* TExecuteWithCallbackDD - Test datastore.TExecuteWithCallback
//*               for Domino.Doc connector
//*      
//*****************************************************************************


#include "stdafx.h"
#include "TExecuteWithCallbackDD.h"
#include "TCallbackDD.hpp"
#include "DKDatastoreDD.hpp"
#include "dkQueryableCollection.hpp"
#include "dkResultSetCursor.hpp"
#include "dkResultSetCursorScrollable.hpp"
//#include "DKResultSetCursorScrollableDD.hpp"
#include "DKAny.hpp"
#include "DKResults.hpp"
#include "DKEntityDefDD.hpp"
#include "DKAttrDefDD.hpp"
#include "DKException.hpp"

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

void printDDO(DKDDO* ddo)
{
	if(ddo != NULL)
	{
		DKPid p = ddo->getPid();
		cout << "DDO" << endl;
		cout << "PID ID: " << p.getIdString() << endl;
	}
}


void printResults(dkResultSetCursor* pResults)
{
	if(pResults != NULL)
	{
		 DKDDO* item = NULL;
         for (item = pResults->fetchNext(); pResults->isValid() && !pResults->isEnd(); item = pResults->fetchNext())
		 {
			printDDO(item);
			if(item != NULL)
				delete item;
		 }
	}
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}

	for( int nbrArgs = 1; nbrArgs < argc; nbrArgs++ )
	{
		cout << "TListAttrsDD parm " << nbrArgs << "= "<< argv[nbrArgs] << endl;
	}
	if( nbrArgs < 4 )
	{
	    cout << "TListAttrsDD usage = <serverName> <userId> <pw>" << endl;
		return -1;
	}

    try 
	{
		DKDatastoreDD dsDD;
	    TCallbackDD cbkDD;
		DKNVPair* parms = 0;
		dkResultSetCursor* pCur = 0;
		cout << "Datastore DD created" << endl;
		cout << "connecting to datastore" << endl;
		dsDD.connect(argv[1],argv[2],argv[3]);
		
		
		
	//	DKString qString0("((NOT([\"DocFormat\"]CONTAINS\"NOTES\"))  AND  ([\"Description\"]CONTAINS\"Request*\"))");
		DKString qString0(" ([\"DocType\"]CONTAINS\"D*\")");
		DKString queryParms0("ENTITY=WebPublishing;QUERY=");
		DKString queryString0 = queryParms0 + qString0;
		cout << "Query: " << queryString0 << endl;
		
		cout << "executing query" << endl;
		dsDD.executeWithCallback(queryString0, DK_CM_PARAMETRIC_QL_TYPE, parms,(dkCallback*)&cbkDD);
		cout << "query executed" << endl;
		
		DKBoolean isDone = FALSE;
		while (isDone == FALSE)
		{
			cout << "press <enter> to continue... " << endl;
			getchar();
			isDone = cbkDD.isDone();
			cout << "isDone: " << ((isDone == TRUE) ? "True" : "False") << endl;
		}

		dsDD.disconnect();
		cout << "datastore disconnected" << endl;
    }
    catch(DKException &exc)
    {
		cout << "Error id " << exc.errorId() << endl;
	    cout << "Exception id " << exc.exceptionId() << endl;
		for(unsigned long i = 0; i< exc.textCount();i++)
		{
			cout << "Error text: " << exc.text(i) << endl;
		}
		for (unsigned long g=0; g< exc.locationCount();g++)
		{
			const DKExceptionLocation* p = exc.locationAtIndex(g);
			cout << "Filename: " << p->fileName() << endl;
			cout << "Function: " << p->functionName() << endl;
			cout << "LineNumber: " << p->lineNumber() << endl;
		}
		cout << "Exception Class Name: " << exc.name() << endl;
    }
	return nRetCode;
}
