/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

import com.ibm.mm.beans.*;

/**
 * This sample lists the available data sources of a particular type.  Data sources
 * are typically content servers, but they may also be databases or other identifiers
 * of sources of content.
 * <p>
 * The method of defining available data sources depends on the type of datastore,
 * but the information is usually kept in a properties file or the system registry.
 */
public class TListDataSources {

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            System.out.println(
                "Lists names of available data sources. \n"
                    + "Syntax: \n"
                    + "  java TListDataSources <dstype> \n"
                    + "where: \n"
                    + "  <dstype> is the datastore type (Fed, ICM, DL, OD, DB2)");
            System.exit(0);
        }
        
        String dstype = args[0];
        
        CMBConnection connection = new CMBConnection();
        connection.setDsType(dstype);
        String[] dataSources = connection.listDataSources();
        System.out.println("Available data sources:");
        for (int i = 0; i < dataSources.length; i++) {
            System.out.println("  " + dataSources[i]);
        }
    }

}