/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample to list servers, and list schema from a QBIC Search datastore

/*
 * Filename       : TClientListCatalog2QBIC.java
 * Description    : test DKDatastoreQBIC for list functions
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;


public class TClientListCatalog2QBIC implements DKConstantDL {

  public static void main(String argv[])
  {
   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    System.out.println("begin...");
    String str;
    DKSequentialCollection col;
    dkIterator iter;
    DKSequentialCollection col2;
    dkIterator iter2;
    DKSequentialCollection col3;
    dkIterator iter3;
    DKServerDefQBIC srvDef;
    DKDatastoreDefQBIC dsDef = null;
    DKDatabaseDefQBIC dbDef;
    DKCatalogDefQBIC catDef;
    DKFeatureDefQBIC featDef;

    DKDatastoreQBIC dsQBIC = null;
    try {
    dsQBIC = new DKDatastoreQBIC();
    System.out.println("Datastore QBIC created");
    System.out.println("connecting to datastore");
    dsQBIC.connect("QBICSRV","QBICUSER","PASSWORD","");
    System.out.println("datastore connected");

    System.out.println("------ QBIC listServers ");
	col = (DKSequentialCollection)dsQBIC.listDataSources();
	iter = col.createIterator();
	while (iter.more() == true)
	{
	    srvDef = (DKServerDefQBIC)iter.next();
	    System.out.println("Server name = " + srvDef.getName());
	    System.out.println("Host name = " + srvDef.getHostName());
	    System.out.println("Port Number = " + srvDef.getPortNumber());
	}

    System.out.println("------ QBIC listDatabases ");
    dsDef = (DKDatastoreDefQBIC)dsQBIC.datastoreDef();
	col = (DKSequentialCollection)dsDef.listEntities();
	iter = col.createIterator();
	while (iter.more() == true)
	{
	 dbDef = (DKDatabaseDefQBIC)iter.next();
	 System.out.println("DB name = " + dbDef.getName());
         System.out.println("------ QBIC listCatalogs for DB " +
                             dbDef.getName());
         col2 = (DKSequentialCollection)dbDef.listSubEntities();
  	 iter2 = col2.createIterator();
     while (iter2.more() == true)
	 {
	  catDef = (DKCatalogDefQBIC)iter2.next();
	  System.out.println("Catalog name = " + catDef.getName());
          System.out.println("------ QBIC listFeatures for Catalog " +
                              catDef.getName());
          col3 = (DKSequentialCollection)catDef.listAttrs();
  	  iter3 = col3.createIterator();
      while (iter3.more() == true)
	  {
	   featDef = (DKFeatureDefQBIC)iter3.next();
	   System.out.println("Feature name = " + featDef.getName());
      }
     }
	}
    dsQBIC.disconnect();
    System.out.println("datastore disconnected");
    dsQBIC.destroy();
    }
    catch(DKException exc)
    {
     try {
         dsQBIC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch(Exception exc)
    {
     try {
         dsQBIC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

    System.out.println("done ...");
  }
}

