/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//*****************************************************************************
// txdoDelVSDL.java - Test DKBlobDL for delete and using extension object
// (this test case requires you to know the existing partId and itemId)
// invoke: java txdoDelVSDL <partId> <repType> <itemId>
// You can also code the partId, repType and itemId in this program and
// invoke as: java txdoDelVSDL
//*****************************************************************************
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdoDelVSDL implements DKConstantDL
{
 //replace following with your library server name, userid, pasword
 public static final String STR_LIB_SERVER  = "LIBSRVRN";
 public static final String STR_USER_ID     = "FRNADMIN";
 public static final String STR_PASSWORD    = "PASSWORD";

 public static void main(String args[])
 {
    int  partId = 45; 
    String repType = ""; 
    String itemId =  "K5#NLPETZ#TU2D$2"; 

    if (args.length == 3)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      itemId = args[2];
      System.out.println("You enter: java txdoDelVSDL " +
       + partId + " " + repType + " " + itemId);
    }
    if (args.length == 2)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      System.out.println("You enter: java txdoDelVSDL " +
       + partId + " " + repType);
    }
    if (args.length == 1)
    {
      partId =(short)Integer.parseInt(args[0], 10);
      System.out.println("You enter: java txdoDelVSDL " + partId );
      System.out.println("The supplied default repType = " + repType);
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdoDelVSDL <partId> <repType> <itemId>");
      System.out.println("No parameter, folldeowing defaults will be provided:");
      System.out.println("     default partId = " + partId);
      System.out.println("     default repType = " + repType);
      System.out.println("     default itemId = " + itemId);
    } 
   
    DKDatastoreDL dsDL = null;
    try 
    {
      dsDL = new DKDatastoreDL();
      System.out.println("connecting to datastore..."); 
      dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
      System.out.println("datastore connected"); 

      DKBlobDL axdo = new DKBlobDL(dsDL);
      DKPidXDODL  apid = new DKPidXDODL();
      apid.setPartId(partId);
      apid.setPrimaryId(itemId);
      apid.setRepType(repType);
      axdo.setPidObject(apid);
      boolean flag = axdo.isCategoryOf(DK_DL_INDEXED_OBJECT);
      boolean flag2 = axdo.isCategoryOf(DK_DL_MEDIA_OBJECT);
      System.out.println("isIndexedObject?=" + flag);
      System.out.println("isMediaObject?=" + flag2);
      if (flag)
      {
        DKSearchEngineInfoDL srch = (DKSearchEngineInfoDL)axdo.getExtension("DKSearchEngineInfoDL");
        System.out.println("  serverName=" + srch.getServerName()); 
        System.out.println("  textIndex=" + srch.getTextIndex());
        System.out.println("  timeStamp=" + srch.getSearchTimestamp());
        System.out.println("  searchIndex=" + srch.getSearchIndex());  
        System.out.println("  indexedState=" + axdo.retrieveObjectState(DK_INDEXED_OBJECT)); 
      }
      if (flag2)
      {
        DKMediaStreamInfoDL media = (DKMediaStreamInfoDL)axdo.getExtension("DKMediaStreamInfoDL");
        System.out.println(" mediaformat=" + media.getMediaFormat());
        System.out.println(" mediaBitRate=" + media.getMediaBitRate());
        System.out.println(" mediastate(dynamic)=" + axdo.retrieveObjectState(DK_MEDIA_OBJECT));
        //set delete option for media object
        axdo.setOption(DK_DL_OPT_DELETE_OPTION, 
          (Object)new Integer(DK_DL_DELETE_NO_DROPITEM_MEDIA_AVAIL));
        System.out.println("The setted delete option =" +
          (Integer)(axdo.getOption(DK_OPT_DL_DELETE_OPTION)));   
      }

      System.out.println("about to call del() - default flush is true");
      axdo.del();
      System.out.println("del successfully.....");
      flag2 = axdo.isCategoryOf(DK_DL_MEDIA_OBJECT);
      System.out.println("after delete isMediaObject? = " + flag2);
   
      System.out.println("about to call dsDL.disconnect()");
      dsDL.disconnect();
      System.out.println("datastore disconnected"); 
      dsDL.destroy();
    }
    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " );
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

