/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/*************************************************************************
* txdomiscDL.java - Test DKBlobDL 
* invoke: txdomiscDL <partId> <repType> <itemId>
* (this test case requires you to know the existing ItemID and partNo; you
*  also need to replace the library server, userid and password of your own)
*****************************************************************************/
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdomiscDL 
   implements DKConstantDL {
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  public static void main(String args[])
{

    int     partId = 19;                  //replace this with known one
    String  itemId = "K5#NLPETZ#TU2D$2";  //replace this with known one
    String repType = "";
    if (args.length == 3)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      itemId = args[2];
      System.out.println("You enter: java txdomiscDL " +
       + partId + " " + repType + " " + itemId);
    }
    if (args.length == 2)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      System.out.println("You enter: java txdomiscDL " +
       + partId + " " + repType);
    }
    if (args.length == 1)
    {
      partId =(short)Integer.parseInt(args[0], 10);
      System.out.println("You enter: java txdomiscDL " + partId );
      System.out.println("The supplied default repType = " + repType);
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdomiscDL <partId> <repType> <itemId>");
      System.out.println("No parameter, folldeowing defaults will be provided:");
      System.out.println("     default partId = " + partId);
      System.out.println("     default repType = " + repType);
      System.out.println("     default itemId = " + itemId);
    } 
    
    DKDatastoreDL dsDL = null;
    try {
      dsDL = new DKDatastoreDL();
      System.out.println("connecting to datastore"); 
      dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
      System.out.println("datastore connected"); 

      DKBlobDL axdo = new DKBlobDL(dsDL);
      DKPidXDODL  apid = new DKPidXDODL();
      apid.setPartId(partId);
      apid.setItemId(itemId);
      apid.setRepType(repType);
      axdo.setPidObject(apid);
      System.out.println("repType=" + apid.getRepType());
      System.out.println("itemid=" + apid.getItemId());
      System.out.println("partId=" + apid.getPartId());

      //== before retrieve
      System.out.println("before retrieve:"); 
      System.out.println("  contentclass=" + axdo.getContentClass());
      System.out.print("  content length=" + axdo.length());
      System.out.println(" (the length of this object instance - in memory)");
      System.out.print("  getSize=" + axdo.getSize());
      System.out.println(" (get the object size without retrieving object)");
      System.out.println("  createdTimestamp=" + axdo.getCreatedTimestamp());
      System.out.println("  updatedTimestamp=" + axdo.getUpdatedTimestamp());
      axdo.retrieve();
      //== after retrieve
      System.out.println("after retrieve:"); 
      System.out.println("  contentclass=" + axdo.getContentClass());
      System.out.print("  content length=" + axdo.length());
      System.out.println(" (the length of this object instance - in memory)");
      System.out.print("  getSize=" + axdo.getSize());
      System.out.println(" (get the object size without retrieving object)");
      System.out.println("  createdTimestamp=" + axdo.getCreatedTimestamp());
      System.out.println("  updatedTimestamp=" + axdo.getUpdatedTimestamp());
      System.out.println("affiliatedTyp=" + axdo.getAffiliatedType());
      if (axdo.getAffiliatedType() == DK_DL_ANNOTATION)
      {
       DKAnnotationDL ann = (DKAnnotationDL)(axdo.getExtension("DKAnnotationDL"));
       System.out.println("affil pageNumber=" + ann.getPageNumber());
       System.out.println("affil X=" + ann.getX());
       System.out.println("affil Y=" + ann.getY());
      }

      System.out.println("about to do open()...");
      axdo.setInstanceOpenHandler("notepad", true); 
      int cc = axdo.getContentClass();
      if ( cc == DK_DL_CC_GIF)
       axdo.setInstanceOpenHandler("lviewpro", true); 
      else if (cc == DK_DL_CC_ASCII)
       axdo.setInstanceOpenHandler("notepad", true); 
      else if (cc == DK_DL_CC_AVI)
       axdo.setInstanceOpenHandler("mplay32 ", true);       
      axdo.open();

      dsDL.disconnect();
      System.out.println("datastore disconnected"); 
      dsDL.destroy();
    }
    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     //System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

