/* -------------------------------------------------------------------
 * @copyright(disclaimer) 
 * IBM Enterprise Information Portal for Multiplatforms V7.1  (program number 5697-G29) 
 * (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
 * IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03) 
 * (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved. 
 * 
 * US Government Users Restricted Rights 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.  Licensed Materials - Property of IBM 
 * 
 * DISCLAIMER OF WARRANTIES : 
 * 
 * Permission is granted to copy and modify this code, and to 
 * distribute modified versions provided that both the copyright 
 * notice and this permission notice appear in all copies and modified 
 * versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS 
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM 
 * WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE 
 * OF THE CODE.
 * 
 * @endCopyright
 */

// sample connect/disconnect to IC

/*
 * Filename       : TCSConnectIC.java
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;

// TCSConnectIC class
public class TCSConnectIC implements DKConstantIC
{

  // Main method
  public static void main(String argv[])
  {

      //*** for input parameters
      String database = new String(""), // database
             userid   = new String(""), //userid
             pw       = new String(""); // password

      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------

      if (argv.length < 3)
      {
         System.out.println("Usage: " );
         System.out.println("  java TCSConnectIC " +
                          "<database> <userid> <pw>" );
         return;
      }
      else
      {
         database = argv[0];
         userid = argv[1];
         pw = argv[2];
      }

      try
      {
         DKDatastoreIC dsIC = new DKDatastoreIC();

         System.out.println("---Connecting to Information Catalog ---");
         dsIC.connect(database, userid, pw, "");

         if ( dsIC.isConnected() )
         {
            System.out.println("--- datastore connected ---");
         }
         else
         {
            System.out.println("--- datastore not connected ---");
         }

         String userName = dsIC.userName();
         System.out.println("--- user : " + userName + " ---");


         String dsName = dsIC.datastoreName();
         System.out.println("--- dsName : " + dsName + " ---");


         dsIC.disconnect();
         System.out.println("--- datastore disconnected ---");
         dsIC.destroy();

      }
      catch (DKException exc)
      {
         System.out.println("Exception name    : " + exc.name());
         System.out.println("Exception message : " + exc.getMessage());
         exc.printStackTrace();
      }
      catch (Exception exc)
      {
         System.out.println("Exception message : " + exc.getMessage());
         exc.printStackTrace();
      }
   }
}

