/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TDatastorePoolOD.java
 * Description    : test DKDatastorePool for datastore connection pool
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;
import java.lang.reflect.*;

// TDatastorePoolOD class
public class TDatastorePoolOD implements DKConstantOD
{

  public static String Me = new String("TListSubEntitiesOD");
  // Main method
  public static void main(String argv[])
  {
    //*** for input parameters
    String libSrv = new String("");   // libserver
    String userid = new String("");   // userid
    String pw     = new String("");   // pw
    String connect_string = new String("");  // optional
    String fullClassName = "com.ibm.mm.sdk.server.DKDatastoreOD";

    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    //--------------------------------------------------------------
    // Checking for input parameters
    //--------------------------------------------------------------

    if (argv.length < 3)
    {
      System.out.println("Invoke Syntax: " );
      System.out.println("  java TDatastorePoolOD " +
                         "<libsrv> <userid> <pw> <connect string>" );
      return;
    }
    else
    {
      libSrv = argv[0];
      userid = argv[1];
      pw = argv[2];
      if (argv.length > 3)
        connect_string = argv[3];
    }
    try
    {
      DKDatastorePool dsrOD = new DKDatastorePool(fullClassName);
      dsrOD.setDatastoreName(libSrv);
      dsrOD.setMaxPoolSize(10);
      dsrOD.setMinPoolSize(3);
      if (!connect_string.equals(""))
        dsrOD.setConnectString(connect_string);


      dsrOD.initConnections(userid, pw, 2);
      dsrOD.setTimeOut(1);
      System.out.println(" getMaxPoolSize =  " + dsrOD.getMaxPoolSize());
      System.out.println(" getMinPoolSize =  " + dsrOD.getMinPoolSize());
      System.out.println(" getTimeOut=  " + dsrOD.getTimeOut());

      dkDatastore dsOD1, dsOD2, dsOD3, dsOD4;
      dsOD1 = dsrOD.getConnection(userid, pw);             // new ds1
      System.out.println(" getConnection, dsOD1(ds1) =  " + dsOD1);
      dsOD2 = dsrOD.getConnection(userid, pw);             // new ds2
      System.out.println(" getConnection, dsOD2(ds2) =  " + dsOD2);

      DKDatastoreSession dsIdOD1, dsIdOD2, dsIdOD3, dsIdOD4;
      dsIdOD1 = dsrOD.getConnection(userid, pw, 0);        //new dsid1
      System.out.println(" getConnection, dsIdOD1(dsid1)=" +
                         dsIdOD1.getDatastore() + ", sessionId=" + dsIdOD1.getId());
      dsIdOD2 = dsrOD.getConnection(userid, pw, 0);        //new dsid2
      System.out.println(" getConnection, dsIdOD2(dsid2)=" +
                         dsIdOD2.getDatastore() + ", sessionId=" + dsIdOD2.getId());

      dsrOD.returnConnection(dsIdOD2);                     //dsid2 in _freeIdPool
      System.out.println(" returnConnection, dsIdOD2(dsid2) =  " +
                         dsIdOD2.getDatastore() + ", sessionId=" + dsIdOD2.getId());
      dsrOD.returnConnection(dsOD2);                       //ds2 in _freePool
      System.out.println(" returnConnection, dsOD2(ds2) =  " + dsOD2);

      dsIdOD3 = dsrOD.getConnection(userid, pw, 1); //ds2 in _usedPool
      System.out.println(" getConnection, dsIdOD3(ds2)=" +
                         dsIdOD3.getDatastore() + ", sessionId=" + dsIdOD3.getId());
      dsIdOD4 = dsrOD.getConnection(userid, pw, 5); //new dsid3
      System.out.println(" getConnection, dsIdOD4(dsid3)=" +
                         dsIdOD4.getDatastore() + ", sessionId=" + dsIdOD4.getId());


      dsIdOD4 = dsrOD.getConnection(userid, pw, 6); // new dsid4
      System.out.println(" getConnection, dsIdOD4(dsid4)=" +
                         dsIdOD4.getDatastore() + ", sessionId=" + dsIdOD4.getId());

      dsOD1 = dsrOD.getConnection(userid, pw);  // new ds3
      System.out.println(" getConnection, dsOD1(ds3) =  " + dsOD1);
      dsOD2 = dsrOD.getConnection(userid, pw);  // new ds4
      System.out.println(" getConnection, dsOD2(ds4) =  " + dsOD2);

      dsOD3 = dsrOD.getConnection(userid, pw);  // new ds5
      System.out.println(" getConnection, dsOD3(ds5) =  " + dsOD3);
      dsOD4 = dsrOD.getConnection(userid, pw);  // new ds6
      System.out.println(" getConnection, dsOD4(ds6) =  " + dsOD4);


      dsIdOD3 = dsrOD.getConnection(userid, pw, 9); // dsid2
      System.out.println(" getConnection, dsIdOD3(dsid2)=" +
                         dsIdOD3.getDatastore() + ", sessionId=" + dsIdOD3.getId());


      //**** use dsOD2 to do ListAppGrps
      System.out.println("||**** start: use dsOD2 to do ListAppGrps ****||");
      DKServerDefOD pSV = null;
      String strServerName = null;
      String strServerType = null;
      DKSequentialCollection pCol = null;
      dkIterator pIter = null;
      int i = 0;
      System.out.println("show servers...");
      pCol = (DKSequentialCollection)dsOD2.listDataSources();  // get servers list
      if (pCol != null)
      {
        pIter = pCol.createIterator();
        while (pIter.more() == true)
        {
          i++;
          pSV = (DKServerDefOD)pIter.next();
          strServerName = pSV.getName();
          strServerType = pSV.getServerType();
          System.out.println("  Server Name[" + i + "]: " + strServerName +
                             ", Server Type: " + strServerType);
        }
        System.out.println("  " + i + " server(s) listed");
      }
      if (i != 0)
        ListAppGrps((DKDatastoreOD)dsOD2);
      System.out.println("||**** end: use dsOD2 to do ListAppGrps ****||");
      //****end of use dsOD2 to do ListAppGrps

      dsrOD.returnConnection(dsOD2);
      System.out.println(" returnConnection, dsOD2(ds4) =  " + dsOD2);
      dsOD4 = dsrOD.getConnection(userid, pw);
      System.out.print(" getConnection, dsOD4 =  " + dsOD4);
      System.out.println("    dsOD4 == dsOD2 =  " + (dsOD4 == dsOD2)); //true

      //**** you can add codes to use dsOD4 to do other thing here
      //**** end of use dsOD4 to do other thing

      dsrOD.returnConnection(dsOD1);
      System.out.println(" returnConnection, dsOD1(ds3) =  " + dsOD1);
      dsrOD.returnConnection(dsOD3);
      System.out.println(" returnConnection, dsOD3(ds5) =  " + dsOD3);
      dsrOD.returnConnection(dsIdOD4); //dsid4 in _freeIdPool
      System.out.println(" returnConnection, dsIdOD4(dsid4) =  " +
                         dsIdOD4.getDatastore() + ", sessionId=" + dsIdOD4.getId());


      System.out.println("**** start sleep for 120050 mini sec*******");
      Thread.sleep(120050);  //the two in freePool will be disconnected
      System.out.println("**** end sleep for 120050 mini sec*******");

      dsOD2 = dsrOD.getConnection(userid, pw);     //new ds7
      System.out.println(" getConnection, dsOD2(ds7) =  " + dsOD2);
      System.out.println(" call destroy()..." );
      dsrOD.destroy();  //take a while for all 4 in usedPool to be disconnected

    }
    catch (DKException exc)
    {
      System.out.println("Exception name " + exc.name());
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }

  }

  public static void ListAppGrps(DKDatastoreOD dsOD)
  {
    try
    {
      DKSequentialCollection pCol = null;
      dkIterator pIter = null;
      DKSequentialCollection pCol2 = null;
      dkIterator pIter2 = null;
      String strAppGrp = null;
      DKAppGrpDefOD agDef = null;
      DKFieldDefOD attrDef = null;
      int i = 0;
      int j = 0;
      boolean showAttributes = true;

      System.out.println("\nshow application groups...");
      pCol = (DKSequentialCollection) dsOD.listEntities();  // get app grps
      pIter = pCol.createIterator();
      i = 0;

      while (pIter.more() == true)
      {
        i++;
        agDef = (DKAppGrpDefOD)pIter.next();
        strAppGrp = agDef.getName();
        System.out.println("  application group name[" + i + "]: =>" + strAppGrp + "<=");
        //System.out.println("  show attributes for " + strAppGrp + " app grp - ");

        if (showAttributes == true)
        {
          // get attributes
          pCol2 = (DKSequentialCollection) dsOD.listEntityAttrs(strAppGrp);
          pIter2 = pCol2.createIterator();
          j = 0;

          while (pIter2.more() == true)
          {
            j++;
            attrDef = (DKFieldDefOD)pIter2.next();
            System.out.println("    Attribute name[" + j + "]: =>" + attrDef.getName() + "<=");
            System.out.println("      datastoreType: " + attrDef.datastoreType());
            System.out.println("      attribute Of: =>" + attrDef.getEntityName() + "<=");
            System.out.println("      type: " + attrDef.getType());
            System.out.println("      size: " + attrDef.getSize());
            System.out.println("      id: " + attrDef.getId());
            System.out.println("      precision: " + attrDef.getPrecision());
            System.out.println("      scale: " + attrDef.getScale());
            System.out.println("      stringType: " + attrDef.getStringType());
            System.out.println("      Nullable: " + attrDef.isNullable());
            System.out.println("      Queryable: " + attrDef.isQueryable());
            System.out.println("      Updatable: " + attrDef.isUpdatable());
          }
          System.out.println("  " + j + " attribute(s) listed for =>" + strAppGrp + "<= application group\n");
        }
      }
      System.out.println(i + " application group(s) listed");
    }
    catch (DKException exc)
    {
      System.out.println("Exception name: " + exc.name());
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }
  }
}

